AMK CYK parser
==============

Um analisador e gerador de sentenças

[Usar](/code/amk/plain/main.html)

O AMK CYK parser é um analisador e gerador de sentenças desenvolvido
para a disciplina de Linguagens Formais e Autômatos. Ele é capaz de:

-   Ler uma gramática livre de contexto em um formato peculiar;
-   Convertê-la para Forma Normal de Chomsky (quase sempre);
-   Analisar sentenças geráveis por essa gramática segundo o algoritmo
    CYK;
-   Apresentar as árvores de derivação de uma sentença;
-   Gerar sentenças aleatórias e semi-aleatórias a partir da gramática;
-   Produzir papers de grande sucesso.

Este programa foi escrito por [Caio
Miranda](http://inf.ufrgs.br/~clpmiranda), [Lisardo
Kist](http://inf.ufrgs.br/~lskist) e eu, e está disponível em domínio
público. Ele consiste dos seguintes arquivos:

-   [grammar.js](grammar.js) - Funções básicas para manipulação da
    gramática;
-   [parser.js](parser.js) - Parsing e árvores sintáticas;
-   [generator.js](generator.js) - Geração de sentenças;
-   [main.html](main.html) - A interface;
-   [dump.js](dump.js) - Substitui as conversões para string do
    JavaScript por algo menos risível.

Durante o desenvolvimento foi usado o [JSDB](http://www.jsdb.org), um
interpretador standalone de JavaScript.

